unit DaemonUnit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DateUtils, FileUtil, DaemonApp, log,// MPlayerDebugerPipeServer;
  Win32Int, Windows, InterfaceBase;

type

  { TDaemon1 }

  { MyThread }

  MyThread = Class(TThread)
  public

    constructor Create;
    destructor Destroy; override;
    procedure Execute; override;
  private
    MessageHandle : HWND;
    procedure MyMessage(Var Mesg:TMessage);
  end;

  TDaemon1 = class(TDaemon)
    procedure DataModuleDestroy(Sender: TObject);
    procedure DataModuleExecute(Sender: TCustomDaemon);
    procedure DataModuleShutDown(Sender: TCustomDaemon);
    procedure DataModuleStart(Sender: TCustomDaemon; var OK: Boolean);
    procedure DataModuleStop(Sender: TCustomDaemon; var OK: Boolean);
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleAfterInstall(Sender: TCustomDaemon);
    procedure DataModuleAfterUnInstall(Sender: TCustomDaemon);
    procedure DataModuleBeforeInstall(Sender: TCustomDaemon);
    procedure DataModuleBeforeUnInstall(Sender: TCustomDaemon);
  private
    { private declarations }
  public
    TestThread: MyThread;
    { public declarations }
  end; 

var
  Daemon1: TDaemon1;

implementation

Procedure RegisterDaemon; 
begin
  RegisterDaemonClass(TDaemon1)
end;

{ MyThread }

//constructor MyThread.create;
//begin
//  Inherited Create;
//end;

//destructor MyThread.destroy;
//begin
//  Inherited Destroy;
//end;

constructor MyThread.Create;
begin
  MessageHandle := TWin32WidgetSet(WidgetSet).AllocateHWnd(@MyMessage);
  inherited create(false);
end;

destructor MyThread.Destroy;
begin
  TWin32WidgetSet(WidgetSet).DeallocateHWnd(MessageHandle);
  inherited Destroy;
end;

procedure MyThread.Execute;
var
  LastTime: TDateTime;
begin
  LastTime := Now;
  if Terminated then
     Writelog('sys', 'Thread', #9 + '0' + #9 + 'On Execute Terminated');
  while Not Terminated do
  begin
    if (SecondsBetween(Now,LastTime) < 2) then
      Continue;
    connect;
    writelog('sys', 'Thread', #9 + '0' + #9 + 'On Execute');
    LastTime := now;
  end;
end;

procedure MyThread.MyMessage(Var Mesg: TMessage);
begin

end;

{ TDaemon1 }

procedure TDaemon1.DataModuleDestroy(Sender: TObject);
begin
  writelog('sys', 'Main', #9 + '0' + #9 + 'Destroying service.');
end;

procedure TDaemon1.DataModuleExecute(Sender: TCustomDaemon);
begin

  writelog('sys', 'Main', #9 + '0' + #9 + 'Execute service.');
  TestThread := MyThread.Create;
end;

procedure TDaemon1.DataModuleShutDown(Sender: TCustomDaemon);
begin
  writelog('sys', 'Main', #9 + '0' + #9 + 'Shutdown service.');
end;

procedure TDaemon1.DataModuleStart(Sender: TCustomDaemon; var OK: Boolean);
begin
  writelog('sys', 'Main', #9 + '0' + #9 + 'Initializing service.');


  //sleep(5000);
  // Application.StopDaemons(True);
  // application.terminate;
end;

procedure TDaemon1.DataModuleStop(Sender: TCustomDaemon; var OK: Boolean);
begin
   writelog('sys', 'Main', #9 + '0' + #9 + 'Stopping service.');
end;

procedure TDaemon1.DataModuleCreate(Sender: TObject);
begin

   writelog('sys', 'Main', #9 + '0' + #9 + 'Create service.');
end;

procedure TDaemon1.DataModuleAfterInstall(Sender: TCustomDaemon);
begin
   writelog('sys', 'Main', #9 + '0' + #9 + 'Service installed.');
end;

procedure TDaemon1.DataModuleAfterUnInstall(Sender: TCustomDaemon);
begin
   writelog('sys', 'Main', #9 + '0' + #9 + 'Service UNinstalled.');
end;

procedure TDaemon1.DataModuleBeforeInstall(Sender: TCustomDaemon);
begin
   writelog('sys', 'Main', #9 + '0' + #9 + 'About to install Service.');
end;

procedure TDaemon1.DataModuleBeforeUnInstall(Sender: TCustomDaemon);
begin
   writelog('sys', 'Main', #9 + '0' + #9 + 'About to UNinstall Service.');
end;

{$R *.lfm}


initialization
  RegisterDaemon; 
end.

